let wasm;

let WASM_VECTOR_LEN = 0;

let cachedUint8ArrayMemory0 = null;

function getUint8ArrayMemory0() {
    if (cachedUint8ArrayMemory0 === null || cachedUint8ArrayMemory0.byteLength === 0) {
        cachedUint8ArrayMemory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8ArrayMemory0;
}

const cachedTextEncoder = (typeof TextEncoder !== 'undefined' ? new TextEncoder('utf-8') : { encode: () => { throw Error('TextEncoder not available') } } );

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length, 1) >>> 0;
        getUint8ArrayMemory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len, 1) >>> 0;

    const mem = getUint8ArrayMemory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3, 1) >>> 0;
        const view = getUint8ArrayMemory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);

        offset += ret.written;
        ptr = realloc(ptr, len, offset, 1) >>> 0;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

let cachedDataViewMemory0 = null;

function getDataViewMemory0() {
    if (cachedDataViewMemory0 === null || cachedDataViewMemory0.buffer.detached === true || (cachedDataViewMemory0.buffer.detached === undefined && cachedDataViewMemory0.buffer !== wasm.memory.buffer)) {
        cachedDataViewMemory0 = new DataView(wasm.memory.buffer);
    }
    return cachedDataViewMemory0;
}

function addToExternrefTable0(obj) {
    const idx = wasm.__externref_table_alloc();
    wasm.__wbindgen_export_4.set(idx, obj);
    return idx;
}

function handleError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        const idx = addToExternrefTable0(e);
        wasm.__wbindgen_exn_store(idx);
    }
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches && builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

const cachedTextDecoder = (typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-8', { ignoreBOM: true, fatal: true }) : { decode: () => { throw Error('TextDecoder not available') } } );

if (typeof TextDecoder !== 'undefined') { cachedTextDecoder.decode(); };

function getStringFromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return cachedTextDecoder.decode(getUint8ArrayMemory0().subarray(ptr, ptr + len));
}

function isLikeNone(x) {
    return x === undefined || x === null;
}

function takeFromExternrefTable0(idx) {
    const value = wasm.__wbindgen_export_4.get(idx);
    wasm.__externref_table_dealloc(idx);
    return value;
}
/**
 * @returns {any}
 */
export function q_scheme_color_expanding_methods() {
    const ret = wasm.q_scheme_color_expanding_methods();
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @returns {any}
 */
export function q_scheme_wacg_settings() {
    const ret = wasm.q_scheme_wacg_settings();
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {RGBDifference}
 */
export function differ_in_rgb(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.differ_in_rgb(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return RGBDifference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {RGBDifference}
 */
export function relative_differ_in_rgb(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.relative_differ_in_rgb(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return RGBDifference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {HSLDifference}
 */
export function differ_in_hsl(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.differ_in_hsl(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return HSLDifference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {HSLDifference}
 */
export function relative_differ_in_hsl(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.relative_differ_in_hsl(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return HSLDifference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {HctDiffference}
 */
export function differ_in_hct(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.differ_in_hct(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return HctDiffference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {HctDiffference}
 */
export function relative_differ_in_hct(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.relative_differ_in_hct(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return HctDiffference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {OklchDifference}
 */
export function differ_in_oklch(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.differ_in_oklch(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return OklchDifference.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {string} other
 * @returns {OklchDifference}
 */
export function relative_differ_in_oklch(color, other) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(other, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.relative_differ_in_oklch(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return OklchDifference.__wrap(ret[0]);
}

/**
 * @param {string} basic_color
 * @param {string} mixed_color
 * @returns {MixReversing}
 */
export function tint_scale(basic_color, mixed_color) {
    const ptr0 = passStringToWasm0(basic_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(mixed_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.tint_scale(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return MixReversing.__wrap(ret[0]);
}

/**
 * @param {string} basic_color
 * @param {string} mixed_color
 * @returns {MixReversing}
 */
export function shade_scale(basic_color, mixed_color) {
    const ptr0 = passStringToWasm0(basic_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(mixed_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.shade_scale(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return MixReversing.__wrap(ret[0]);
}

/**
 * @param {string} color
 * @param {number} degree
 * @returns {string}
 */
export function shift_hue(color, degree) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.shift_hue(ptr0, len0, degree);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

function getArrayJsValueFromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    const mem = getDataViewMemory0();
    const result = [];
    for (let i = ptr; i < ptr + 4 * len; i += 4) {
        result.push(wasm.__wbindgen_export_4.get(mem.getUint32(i, true)));
    }
    wasm.__externref_drop_slice(ptr, len);
    return result;
}
/**
 * @param {string} color
 * @returns {(string)[]}
 */
export function analogous_30(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.analogous_30(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @returns {(string)[]}
 */
export function analogous_60(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.analogous_60(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @returns {string}
 */
export function complementary(color) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.complementary(ptr0, len0);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @returns {(string)[]}
 */
export function split_complementary(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.split_complementary(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @returns {(string)[]}
 */
export function tetradic(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.tetradic(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @returns {(string)[]}
 */
export function triadic(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.triadic(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
}
/**
 * @param {string} reference_color
 * @param {number} swatch_amount
 * @param {number} minimum_lightness
 * @param {number} maximum_lightness
 * @param {boolean | undefined} [use_reference_color]
 * @param {number | undefined} [reference_color_bias]
 * @returns {(string)[]}
 */
export function generate_palette_from_color(reference_color, swatch_amount, minimum_lightness, maximum_lightness, use_reference_color, reference_color_bias) {
    const ptr0 = passStringToWasm0(reference_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.generate_palette_from_color(ptr0, len0, swatch_amount, minimum_lightness, maximum_lightness, isLikeNone(use_reference_color) ? 0xFFFFFF : use_reference_color ? 1 : 0, isLikeNone(reference_color_bias) ? 0xFFFFFF : reference_color_bias);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @returns {any}
 */
export function color_categories() {
    const ret = wasm.color_categories();
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} tag
 * @param {string | undefined} [category]
 * @returns {any}
 */
export function search_color_cards(tag, category) {
    const ptr0 = passStringToWasm0(tag, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    var ptr1 = isLikeNone(category) ? 0 : passStringToWasm0(category, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len1 = WASM_VECTOR_LEN;
    const ret = wasm.search_color_cards(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} source_color
 * @param {string} error_color
 * @param {any} custom_colors
 * @returns {any}
 */
export function generate_material_design_3_scheme(source_color, error_color, custom_colors) {
    const ptr0 = passStringToWasm0(source_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(error_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.generate_material_design_3_scheme(ptr0, len0, ptr1, len1, custom_colors);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} primary_color
 * @param {string} secondary_color
 * @param {string} error_color
 * @param {any} custom_colors
 * @returns {any}
 */
export function generate_material_design_2_scheme(primary_color, secondary_color, error_color, custom_colors) {
    const ptr0 = passStringToWasm0(primary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(secondary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ptr2 = passStringToWasm0(error_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len2 = WASM_VECTOR_LEN;
    const ret = wasm.generate_material_design_2_scheme(ptr0, len0, ptr1, len1, ptr2, len2, custom_colors);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} primary_color
 * @param {string} danger_color
 * @param {string} success_color
 * @param {string} warning_color
 * @param {string} info_color
 * @param {string} fg_color
 * @param {string} bg_color
 * @param {SchemeSetting} setting
 * @returns {any}
 */
export function generate_q_scheme_automatically(primary_color, danger_color, success_color, warning_color, info_color, fg_color, bg_color, setting) {
    const ptr0 = passStringToWasm0(primary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(danger_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ptr2 = passStringToWasm0(success_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len2 = WASM_VECTOR_LEN;
    const ptr3 = passStringToWasm0(warning_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len3 = WASM_VECTOR_LEN;
    const ptr4 = passStringToWasm0(info_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len4 = WASM_VECTOR_LEN;
    const ptr5 = passStringToWasm0(fg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len5 = WASM_VECTOR_LEN;
    const ptr6 = passStringToWasm0(bg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len6 = WASM_VECTOR_LEN;
    _assertClass(setting, SchemeSetting);
    var ptr7 = setting.__destroy_into_raw();
    const ret = wasm.generate_q_scheme_automatically(ptr0, len0, ptr1, len1, ptr2, len2, ptr3, len3, ptr4, len4, ptr5, len5, ptr6, len6, ptr7);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} primary_color
 * @param {string | undefined} secondary_color
 * @param {string | undefined} tertiary_color
 * @param {string | undefined} accent_color
 * @param {string} danger_color
 * @param {string} success_color
 * @param {string} warning_color
 * @param {string} info_color
 * @param {string} fg_color
 * @param {string} bg_color
 * @param {SchemeSetting} setting
 * @returns {any}
 */
export function generate_q_scheme_manually(primary_color, secondary_color, tertiary_color, accent_color, danger_color, success_color, warning_color, info_color, fg_color, bg_color, setting) {
    const ptr0 = passStringToWasm0(primary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    var ptr1 = isLikeNone(secondary_color) ? 0 : passStringToWasm0(secondary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len1 = WASM_VECTOR_LEN;
    var ptr2 = isLikeNone(tertiary_color) ? 0 : passStringToWasm0(tertiary_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len2 = WASM_VECTOR_LEN;
    var ptr3 = isLikeNone(accent_color) ? 0 : passStringToWasm0(accent_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    var len3 = WASM_VECTOR_LEN;
    const ptr4 = passStringToWasm0(danger_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len4 = WASM_VECTOR_LEN;
    const ptr5 = passStringToWasm0(success_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len5 = WASM_VECTOR_LEN;
    const ptr6 = passStringToWasm0(warning_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len6 = WASM_VECTOR_LEN;
    const ptr7 = passStringToWasm0(info_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len7 = WASM_VECTOR_LEN;
    const ptr8 = passStringToWasm0(fg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len8 = WASM_VECTOR_LEN;
    const ptr9 = passStringToWasm0(bg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len9 = WASM_VECTOR_LEN;
    _assertClass(setting, SchemeSetting);
    var ptr10 = setting.__destroy_into_raw();
    const ret = wasm.generate_q_scheme_manually(ptr0, len0, ptr1, len1, ptr2, len2, ptr3, len3, ptr4, len4, ptr5, len5, ptr6, len6, ptr7, len7, ptr8, len8, ptr9, len9, ptr10);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

function passArrayJsValueToWasm0(array, malloc) {
    const ptr = malloc(array.length * 4, 4) >>> 0;
    const mem = getDataViewMemory0();
    for (let i = 0; i < array.length; i++) {
        mem.setUint32(ptr + 4 * i, addToExternrefTable0(array[i]), true);
    }
    WASM_VECTOR_LEN = array.length;
    return ptr;
}
/**
 * @param {(SwatchEntry)[]} colors
 * @param {SwatchSchemeSetting} setting
 * @returns {any}
 */
export function generate_swatch_scheme(colors, setting) {
    const ptr0 = passArrayJsValueToWasm0(colors, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    _assertClass(setting, SwatchSchemeSetting);
    var ptr1 = setting.__destroy_into_raw();
    const ret = wasm.generate_swatch_scheme(ptr0, len0, ptr1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return takeFromExternrefTable0(ret[0]);
}

/**
 * @param {string} color
 * @param {number} percent
 * @returns {string}
 */
export function lighten(color, percent) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.lighten(ptr0, len0, percent);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} value
 * @returns {string}
 */
export function lighten_absolute(color, value) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.lighten_absolute(ptr0, len0, value);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} percent
 * @returns {string}
 */
export function darken(color, percent) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.darken(ptr0, len0, percent);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} value
 * @returns {string}
 */
export function darken_absolute(color, value) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.darken_absolute(ptr0, len0, value);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color1
 * @param {string} color2
 * @param {number} percent
 * @returns {string}
 */
export function mix(color1, color2, percent) {
    let deferred4_0;
    let deferred4_1;
    try {
        const ptr0 = passStringToWasm0(color1, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ptr1 = passStringToWasm0(color2, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        const ret = wasm.mix(ptr0, len0, ptr1, len1, percent);
        var ptr3 = ret[0];
        var len3 = ret[1];
        if (ret[3]) {
            ptr3 = 0; len3 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred4_0 = ptr3;
        deferred4_1 = len3;
        return getStringFromWasm0(ptr3, len3);
    } finally {
        wasm.__wbindgen_free(deferred4_0, deferred4_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} percent
 * @returns {string}
 */
export function tint(color, percent) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.tint(ptr0, len0, percent);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} percent
 * @returns {string}
 */
export function shade(color, percent) {
    let deferred3_0;
    let deferred3_1;
    try {
        const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.shade(ptr0, len0, percent);
        var ptr2 = ret[0];
        var len2 = ret[1];
        if (ret[3]) {
            ptr2 = 0; len2 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred3_0 = ptr2;
        deferred3_1 = len2;
        return getStringFromWasm0(ptr2, len2);
    } finally {
        wasm.__wbindgen_free(deferred3_0, deferred3_1, 1);
    }
}

/**
 * @param {string} color
 * @param {number} expand_amount
 * @param {number} step
 * @returns {(string)[]}
 */
export function series(color, expand_amount, step) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.series(ptr0, len0, expand_amount, step);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @param {number} expand_amount
 * @param {number} step
 * @returns {(string)[]}
 */
export function tonal_lighten_series(color, expand_amount, step) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.tonal_lighten_series(ptr0, len0, expand_amount, step);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {string} color
 * @param {number} expand_amount
 * @param {number} step
 * @returns {(string)[]}
 */
export function tonal_darken_series(color, expand_amount, step) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.tonal_darken_series(ptr0, len0, expand_amount, step);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayJsValueFromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

function getArrayU8FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getUint8ArrayMemory0().subarray(ptr / 1, ptr / 1 + len);
}
/**
 * @param {string} color
 * @returns {Uint8Array}
 */
export function represent_rgb(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.represent_rgb(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayU8FromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 1, 1);
    return v2;
}

/**
 * @param {number} r
 * @param {number} g
 * @param {number} b
 * @returns {string}
 */
export function rgb_to_hex(r, g, b) {
    let deferred2_0;
    let deferred2_1;
    try {
        const ret = wasm.rgb_to_hex(r, g, b);
        var ptr1 = ret[0];
        var len1 = ret[1];
        if (ret[3]) {
            ptr1 = 0; len1 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred2_0 = ptr1;
        deferred2_1 = len1;
        return getStringFromWasm0(ptr1, len1);
    } finally {
        wasm.__wbindgen_free(deferred2_0, deferred2_1, 1);
    }
}

let cachedFloat32ArrayMemory0 = null;

function getFloat32ArrayMemory0() {
    if (cachedFloat32ArrayMemory0 === null || cachedFloat32ArrayMemory0.byteLength === 0) {
        cachedFloat32ArrayMemory0 = new Float32Array(wasm.memory.buffer);
    }
    return cachedFloat32ArrayMemory0;
}

function getArrayF32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getFloat32ArrayMemory0().subarray(ptr / 4, ptr / 4 + len);
}
/**
 * @param {string} color
 * @returns {Float32Array}
 */
export function represent_hsl(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.represent_hsl(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayF32FromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {number} h
 * @param {number} s
 * @param {number} l
 * @returns {string}
 */
export function hsl_to_hex(h, s, l) {
    let deferred2_0;
    let deferred2_1;
    try {
        const ret = wasm.hsl_to_hex(h, s, l);
        var ptr1 = ret[0];
        var len1 = ret[1];
        if (ret[3]) {
            ptr1 = 0; len1 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred2_0 = ptr1;
        deferred2_1 = len1;
        return getStringFromWasm0(ptr1, len1);
    } finally {
        wasm.__wbindgen_free(deferred2_0, deferred2_1, 1);
    }
}

/**
 * @param {string} color
 * @returns {Float32Array}
 */
export function represent_lab(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.represent_lab(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayF32FromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {number} l
 * @param {number} a
 * @param {number} b
 * @returns {string}
 */
export function lab_to_hex(l, a, b) {
    let deferred2_0;
    let deferred2_1;
    try {
        const ret = wasm.lab_to_hex(l, a, b);
        var ptr1 = ret[0];
        var len1 = ret[1];
        if (ret[3]) {
            ptr1 = 0; len1 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred2_0 = ptr1;
        deferred2_1 = len1;
        return getStringFromWasm0(ptr1, len1);
    } finally {
        wasm.__wbindgen_free(deferred2_0, deferred2_1, 1);
    }
}

/**
 * @param {string} color
 * @returns {Float32Array}
 */
export function represent_oklch(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.represent_oklch(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayF32FromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {number} l
 * @param {number} c
 * @param {number} h
 * @returns {string}
 */
export function oklch_to_hex(l, c, h) {
    let deferred2_0;
    let deferred2_1;
    try {
        const ret = wasm.oklch_to_hex(l, c, h);
        var ptr1 = ret[0];
        var len1 = ret[1];
        if (ret[3]) {
            ptr1 = 0; len1 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred2_0 = ptr1;
        deferred2_1 = len1;
        return getStringFromWasm0(ptr1, len1);
    } finally {
        wasm.__wbindgen_free(deferred2_0, deferred2_1, 1);
    }
}

/**
 * @param {string} color
 * @returns {Float32Array}
 */
export function represent_hct(color) {
    const ptr0 = passStringToWasm0(color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.represent_hct(ptr0, len0);
    if (ret[3]) {
        throw takeFromExternrefTable0(ret[2]);
    }
    var v2 = getArrayF32FromWasm0(ret[0], ret[1]).slice();
    wasm.__wbindgen_free(ret[0], ret[1] * 4, 4);
    return v2;
}

/**
 * @param {number} hue
 * @param {number} chroma
 * @param {number} tone
 * @returns {string}
 */
export function hct_to_hex(hue, chroma, tone) {
    let deferred2_0;
    let deferred2_1;
    try {
        const ret = wasm.hct_to_hex(hue, chroma, tone);
        var ptr1 = ret[0];
        var len1 = ret[1];
        if (ret[3]) {
            ptr1 = 0; len1 = 0;
            throw takeFromExternrefTable0(ret[2]);
        }
        deferred2_0 = ptr1;
        deferred2_1 = len1;
        return getStringFromWasm0(ptr1, len1);
    } finally {
        wasm.__wbindgen_free(deferred2_0, deferred2_1, 1);
    }
}

/**
 * @param {string} fg_color
 * @param {string} bg_color
 * @returns {number}
 */
export function wacg_relative_contrast(fg_color, bg_color) {
    const ptr0 = passStringToWasm0(fg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(bg_color, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    const ret = wasm.wacg_relative_contrast(ptr0, len0, ptr1, len1);
    if (ret[2]) {
        throw takeFromExternrefTable0(ret[1]);
    }
    return ret[0];
}

/**
 * @enum {0 | 1 | 2 | 3 | 4 | 5 | 6}
 */
export const ColorExpand = Object.freeze({
    Complementary: 0, "0": "Complementary",
    Analogous: 1, "1": "Analogous",
    AnalogousAndComplementary: 2, "2": "AnalogousAndComplementary",
    Triadic: 3, "3": "Triadic",
    SplitComplementary: 4, "4": "SplitComplementary",
    Tetradic: 5, "5": "Tetradic",
    Square: 6, "6": "Square",
});
/**
 * @enum {0 | 1 | 2}
 */
export const WACGSetting = Object.freeze({
    Fixed: 0, "0": "Fixed",
    AutomaticAA: 1, "1": "AutomaticAA",
    AutomaticAAA: 2, "2": "AutomaticAAA",
});

const ColorShiftingFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_colorshifting_free(ptr >>> 0, 1));

export class ColorShifting {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ColorShifting.prototype);
        obj.__wbg_ptr = ptr;
        ColorShiftingFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ColorShiftingFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_colorshifting_free(ptr, 0);
    }
    /**
     * @returns {number}
     */
    get chroma() {
        const ret = wasm.__wbg_get_colorshifting_chroma(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set chroma(arg0) {
        wasm.__wbg_set_colorshifting_chroma(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get lightness() {
        const ret = wasm.__wbg_get_colorshifting_lightness(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set lightness(arg0) {
        wasm.__wbg_set_colorshifting_lightness(this.__wbg_ptr, arg0);
    }
}

const DifferFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_differ_free(ptr >>> 0, 1));

export class Differ {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(Differ.prototype);
        obj.__wbg_ptr = ptr;
        DifferFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        DifferFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_differ_free(ptr, 0);
    }
    /**
     * @returns {number}
     */
    get delta() {
        const ret = wasm.__wbg_get_differ_delta(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set delta(arg0) {
        wasm.__wbg_set_differ_delta(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get percent() {
        const ret = wasm.__wbg_get_differ_percent(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set percent(arg0) {
        wasm.__wbg_set_differ_percent(this.__wbg_ptr, arg0);
    }
}

const HSLDifferenceFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_hsldifference_free(ptr >>> 0, 1));

export class HSLDifference {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(HSLDifference.prototype);
        obj.__wbg_ptr = ptr;
        HSLDifferenceFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        HSLDifferenceFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_hsldifference_free(ptr, 0);
    }
    /**
     * @returns {Differ}
     */
    get hue() {
        const ret = wasm.__wbg_get_hsldifference_hue(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set hue(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hsldifference_hue(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get saturation() {
        const ret = wasm.__wbg_get_hsldifference_saturation(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set saturation(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hsldifference_saturation(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get lightness() {
        const ret = wasm.__wbg_get_hsldifference_lightness(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set lightness(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hsldifference_lightness(this.__wbg_ptr, ptr0);
    }
}

const HctDiffferenceFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_hctdiffference_free(ptr >>> 0, 1));

export class HctDiffference {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(HctDiffference.prototype);
        obj.__wbg_ptr = ptr;
        HctDiffferenceFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        HctDiffferenceFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_hctdiffference_free(ptr, 0);
    }
    /**
     * @returns {Differ}
     */
    get hue() {
        const ret = wasm.__wbg_get_hctdiffference_hue(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set hue(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hctdiffference_hue(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get chroma() {
        const ret = wasm.__wbg_get_hctdiffference_chroma(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set chroma(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hctdiffference_chroma(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get lightness() {
        const ret = wasm.__wbg_get_hctdiffference_lightness(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set lightness(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_hctdiffference_lightness(this.__wbg_ptr, ptr0);
    }
}

const MixReversingFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_mixreversing_free(ptr >>> 0, 1));

export class MixReversing {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(MixReversing.prototype);
        obj.__wbg_ptr = ptr;
        MixReversingFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        MixReversingFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_mixreversing_free(ptr, 0);
    }
    /**
     * @returns {number}
     */
    get r_factor() {
        const ret = wasm.__wbg_get_mixreversing_r_factor(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set r_factor(arg0) {
        wasm.__wbg_set_mixreversing_r_factor(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get g_factor() {
        const ret = wasm.__wbg_get_mixreversing_g_factor(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set g_factor(arg0) {
        wasm.__wbg_set_mixreversing_g_factor(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get b_factor() {
        const ret = wasm.__wbg_get_mixreversing_b_factor(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set b_factor(arg0) {
        wasm.__wbg_set_mixreversing_b_factor(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get average() {
        const ret = wasm.__wbg_get_mixreversing_average(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set average(arg0) {
        wasm.__wbg_set_mixreversing_average(this.__wbg_ptr, arg0);
    }
}

const OklchDifferenceFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_oklchdifference_free(ptr >>> 0, 1));

export class OklchDifference {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(OklchDifference.prototype);
        obj.__wbg_ptr = ptr;
        OklchDifferenceFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        OklchDifferenceFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_oklchdifference_free(ptr, 0);
    }
    /**
     * @returns {Differ}
     */
    get hue() {
        const ret = wasm.__wbg_get_oklchdifference_hue(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set hue(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_oklchdifference_hue(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get chroma() {
        const ret = wasm.__wbg_get_oklchdifference_chroma(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set chroma(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_oklchdifference_chroma(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get lightness() {
        const ret = wasm.__wbg_get_oklchdifference_lightness(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set lightness(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_oklchdifference_lightness(this.__wbg_ptr, ptr0);
    }
}

const RGBDifferenceFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_rgbdifference_free(ptr >>> 0, 1));

export class RGBDifference {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(RGBDifference.prototype);
        obj.__wbg_ptr = ptr;
        RGBDifferenceFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        RGBDifferenceFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rgbdifference_free(ptr, 0);
    }
    /**
     * @returns {Differ}
     */
    get r() {
        const ret = wasm.__wbg_get_rgbdifference_r(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set r(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_rgbdifference_r(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get g() {
        const ret = wasm.__wbg_get_rgbdifference_g(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set g(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_rgbdifference_g(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {Differ}
     */
    get b() {
        const ret = wasm.__wbg_get_rgbdifference_b(this.__wbg_ptr);
        return Differ.__wrap(ret);
    }
    /**
     * @param {Differ} arg0
     */
    set b(arg0) {
        _assertClass(arg0, Differ);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_rgbdifference_b(this.__wbg_ptr, ptr0);
    }
}

const SchemeSettingFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_schemesetting_free(ptr >>> 0, 1));

export class SchemeSetting {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        SchemeSettingFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_schemesetting_free(ptr, 0);
    }
    /**
     * @returns {ColorShifting}
     */
    get hover() {
        const ret = wasm.__wbg_get_schemesetting_hover(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set hover(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_schemesetting_hover(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {ColorShifting}
     */
    get active() {
        const ret = wasm.__wbg_get_schemesetting_active(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set active(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_schemesetting_active(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {ColorShifting}
     */
    get focus() {
        const ret = wasm.__wbg_get_schemesetting_focus(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set focus(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_schemesetting_focus(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {ColorShifting}
     */
    get disabled() {
        const ret = wasm.__wbg_get_schemesetting_disabled(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set disabled(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_schemesetting_disabled(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {ColorShifting}
     */
    get dark_convert() {
        const ret = wasm.__wbg_get_schemesetting_dark_convert(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set dark_convert(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_schemesetting_dark_convert(this.__wbg_ptr, ptr0);
    }
    /**
     * @returns {ColorExpand}
     */
    get expand_method() {
        const ret = wasm.__wbg_get_schemesetting_expand_method(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {ColorExpand} arg0
     */
    set expand_method(arg0) {
        wasm.__wbg_set_schemesetting_expand_method(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {WACGSetting}
     */
    get wacg_follows() {
        const ret = wasm.__wbg_get_schemesetting_wacg_follows(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {WACGSetting} arg0
     */
    set wacg_follows(arg0) {
        wasm.__wbg_set_schemesetting_wacg_follows(this.__wbg_ptr, arg0);
    }
}

const SwatchEntryFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_swatchentry_free(ptr >>> 0, 1));

export class SwatchEntry {

    static __unwrap(jsValue) {
        if (!(jsValue instanceof SwatchEntry)) {
            return 0;
        }
        return jsValue.__destroy_into_raw();
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        SwatchEntryFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_swatchentry_free(ptr, 0);
    }
    /**
     * @returns {string}
     */
    get name() {
        let deferred1_0;
        let deferred1_1;
        try {
            const ret = wasm.__wbg_get_swatchentry_name(this.__wbg_ptr);
            deferred1_0 = ret[0];
            deferred1_1 = ret[1];
            return getStringFromWasm0(ret[0], ret[1]);
        } finally {
            wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
        }
    }
    /**
     * @param {string} arg0
     */
    set name(arg0) {
        const ptr0 = passStringToWasm0(arg0, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.__wbg_set_swatchentry_name(this.__wbg_ptr, ptr0, len0);
    }
    /**
     * @returns {string}
     */
    get color() {
        let deferred1_0;
        let deferred1_1;
        try {
            const ret = wasm.__wbg_get_swatchentry_color(this.__wbg_ptr);
            deferred1_0 = ret[0];
            deferred1_1 = ret[1];
            return getStringFromWasm0(ret[0], ret[1]);
        } finally {
            wasm.__wbindgen_free(deferred1_0, deferred1_1, 1);
        }
    }
    /**
     * @param {string} arg0
     */
    set color(arg0) {
        const ptr0 = passStringToWasm0(arg0, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.__wbg_set_swatchentry_color(this.__wbg_ptr, ptr0, len0);
    }
}

const SwatchSchemeSettingFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_swatchschemesetting_free(ptr >>> 0, 1));

export class SwatchSchemeSetting {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        SwatchSchemeSettingFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_swatchschemesetting_free(ptr, 0);
    }
    /**
     * @returns {number}
     */
    get amount() {
        const ret = wasm.__wbg_get_swatchschemesetting_amount(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
     * @param {number} arg0
     */
    set amount(arg0) {
        wasm.__wbg_set_swatchschemesetting_amount(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get min_lightness() {
        const ret = wasm.__wbg_get_swatchschemesetting_min_lightness(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set min_lightness(arg0) {
        wasm.__wbg_set_swatchschemesetting_min_lightness(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {number}
     */
    get max_lightness() {
        const ret = wasm.__wbg_get_swatchschemesetting_max_lightness(this.__wbg_ptr);
        return ret;
    }
    /**
     * @param {number} arg0
     */
    set max_lightness(arg0) {
        wasm.__wbg_set_swatchschemesetting_max_lightness(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {boolean}
     */
    get include_primary() {
        const ret = wasm.__wbg_get_swatchschemesetting_include_primary(this.__wbg_ptr);
        return ret !== 0;
    }
    /**
     * @param {boolean} arg0
     */
    set include_primary(arg0) {
        wasm.__wbg_set_swatchschemesetting_include_primary(this.__wbg_ptr, arg0);
    }
    /**
     * @returns {ColorShifting}
     */
    get dark_convert() {
        const ret = wasm.__wbg_get_swatchschemesetting_dark_convert(this.__wbg_ptr);
        return ColorShifting.__wrap(ret);
    }
    /**
     * @param {ColorShifting} arg0
     */
    set dark_convert(arg0) {
        _assertClass(arg0, ColorShifting);
        var ptr0 = arg0.__destroy_into_raw();
        wasm.__wbg_set_swatchschemesetting_dark_convert(this.__wbg_ptr, ptr0);
    }
}

async function __wbg_load(module, imports) {
    if (typeof Response === 'function' && module instanceof Response) {
        if (typeof WebAssembly.instantiateStreaming === 'function') {
            try {
                return await WebAssembly.instantiateStreaming(module, imports);

            } catch (e) {
                if (module.headers.get('Content-Type') != 'application/wasm') {
                    console.warn("`WebAssembly.instantiateStreaming` failed because your server does not serve Wasm with `application/wasm` MIME type. Falling back to `WebAssembly.instantiate` which is slower. Original error:\n", e);

                } else {
                    throw e;
                }
            }
        }

        const bytes = await module.arrayBuffer();
        return await WebAssembly.instantiate(bytes, imports);

    } else {
        const instance = await WebAssembly.instantiate(module, imports);

        if (instance instanceof WebAssembly.Instance) {
            return { instance, module };

        } else {
            return instance;
        }
    }
}

function __wbg_get_imports() {
    const imports = {};
    imports.wbg = {};
    imports.wbg.__wbg_String_8f0eb39a4a4c2f66 = function(arg0, arg1) {
        const ret = String(arg1);
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_buffer_61b7ce01341d7f88 = function(arg0) {
        const ret = arg0.buffer;
        return ret;
    };
    imports.wbg.__wbg_call_b0d8e36992d9900d = function() { return handleError(function (arg0, arg1) {
        const ret = arg0.call(arg1);
        return ret;
    }, arguments) };
    imports.wbg.__wbg_done_f22c1561fa919baa = function(arg0) {
        const ret = arg0.done;
        return ret;
    };
    imports.wbg.__wbg_entries_4f2bb9b0d701c0f6 = function(arg0) {
        const ret = Object.entries(arg0);
        return ret;
    };
    imports.wbg.__wbg_get_9aa3dff3f0266054 = function(arg0, arg1) {
        const ret = arg0[arg1 >>> 0];
        return ret;
    };
    imports.wbg.__wbg_get_bbccf8970793c087 = function() { return handleError(function (arg0, arg1) {
        const ret = Reflect.get(arg0, arg1);
        return ret;
    }, arguments) };
    imports.wbg.__wbg_instanceof_ArrayBuffer_670ddde44cdb2602 = function(arg0) {
        let result;
        try {
            result = arg0 instanceof ArrayBuffer;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_instanceof_Uint8Array_28af5bc19d6acad8 = function(arg0) {
        let result;
        try {
            result = arg0 instanceof Uint8Array;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_iterator_23604bb983791576 = function() {
        const ret = Symbol.iterator;
        return ret;
    };
    imports.wbg.__wbg_length_65d1cd11729ced11 = function(arg0) {
        const ret = arg0.length;
        return ret;
    };
    imports.wbg.__wbg_length_d65cf0786bfc5739 = function(arg0) {
        const ret = arg0.length;
        return ret;
    };
    imports.wbg.__wbg_new_254fa9eac11932ae = function() {
        const ret = new Array();
        return ret;
    };
    imports.wbg.__wbg_new_3ff5b33b1ce712df = function(arg0) {
        const ret = new Uint8Array(arg0);
        return ret;
    };
    imports.wbg.__wbg_new_688846f374351c92 = function() {
        const ret = new Object();
        return ret;
    };
    imports.wbg.__wbg_new_bc96c6a1c0786643 = function() {
        const ret = new Map();
        return ret;
    };
    imports.wbg.__wbg_next_01dd9234a5bf6d05 = function() { return handleError(function (arg0) {
        const ret = arg0.next();
        return ret;
    }, arguments) };
    imports.wbg.__wbg_next_137428deb98342b0 = function(arg0) {
        const ret = arg0.next;
        return ret;
    };
    imports.wbg.__wbg_set_1d80752d0d5f0b21 = function(arg0, arg1, arg2) {
        arg0[arg1 >>> 0] = arg2;
    };
    imports.wbg.__wbg_set_23d69db4e5c66a6e = function(arg0, arg1, arg2) {
        arg0.set(arg1, arg2 >>> 0);
    };
    imports.wbg.__wbg_set_3f1d0b984ed272ed = function(arg0, arg1, arg2) {
        arg0[arg1] = arg2;
    };
    imports.wbg.__wbg_set_76818dc3c59a63d5 = function(arg0, arg1, arg2) {
        const ret = arg0.set(arg1, arg2);
        return ret;
    };
    imports.wbg.__wbg_swatchentry_unwrap = function(arg0) {
        const ret = SwatchEntry.__unwrap(arg0);
        return ret;
    };
    imports.wbg.__wbg_value_4c32fd138a88eee2 = function(arg0) {
        const ret = arg0.value;
        return ret;
    };
    imports.wbg.__wbindgen_bigint_from_i64 = function(arg0) {
        const ret = arg0;
        return ret;
    };
    imports.wbg.__wbindgen_bigint_from_u64 = function(arg0) {
        const ret = BigInt.asUintN(64, arg0);
        return ret;
    };
    imports.wbg.__wbindgen_boolean_get = function(arg0) {
        const v = arg0;
        const ret = typeof(v) === 'boolean' ? (v ? 1 : 0) : 2;
        return ret;
    };
    imports.wbg.__wbindgen_debug_string = function(arg0, arg1) {
        const ret = debugString(arg1);
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbindgen_error_new = function(arg0, arg1) {
        const ret = new Error(getStringFromWasm0(arg0, arg1));
        return ret;
    };
    imports.wbg.__wbindgen_init_externref_table = function() {
        const table = wasm.__wbindgen_export_4;
        const offset = table.grow(4);
        table.set(0, undefined);
        table.set(offset + 0, undefined);
        table.set(offset + 1, null);
        table.set(offset + 2, true);
        table.set(offset + 3, false);
        ;
    };
    imports.wbg.__wbindgen_is_function = function(arg0) {
        const ret = typeof(arg0) === 'function';
        return ret;
    };
    imports.wbg.__wbindgen_is_object = function(arg0) {
        const val = arg0;
        const ret = typeof(val) === 'object' && val !== null;
        return ret;
    };
    imports.wbg.__wbindgen_is_string = function(arg0) {
        const ret = typeof(arg0) === 'string';
        return ret;
    };
    imports.wbg.__wbindgen_jsval_loose_eq = function(arg0, arg1) {
        const ret = arg0 == arg1;
        return ret;
    };
    imports.wbg.__wbindgen_memory = function() {
        const ret = wasm.memory;
        return ret;
    };
    imports.wbg.__wbindgen_number_get = function(arg0, arg1) {
        const obj = arg1;
        const ret = typeof(obj) === 'number' ? obj : undefined;
        getDataViewMemory0().setFloat64(arg0 + 8 * 1, isLikeNone(ret) ? 0 : ret, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, !isLikeNone(ret), true);
    };
    imports.wbg.__wbindgen_number_new = function(arg0) {
        const ret = arg0;
        return ret;
    };
    imports.wbg.__wbindgen_string_get = function(arg0, arg1) {
        const obj = arg1;
        const ret = typeof(obj) === 'string' ? obj : undefined;
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbindgen_string_new = function(arg0, arg1) {
        const ret = getStringFromWasm0(arg0, arg1);
        return ret;
    };
    imports.wbg.__wbindgen_throw = function(arg0, arg1) {
        throw new Error(getStringFromWasm0(arg0, arg1));
    };

    return imports;
}

function __wbg_init_memory(imports, memory) {

}

function __wbg_finalize_init(instance, module) {
    wasm = instance.exports;
    __wbg_init.__wbindgen_wasm_module = module;
    cachedDataViewMemory0 = null;
    cachedFloat32ArrayMemory0 = null;
    cachedUint8ArrayMemory0 = null;


    wasm.__wbindgen_start();
    return wasm;
}

function initSync(module) {
    if (wasm !== undefined) return wasm;


    if (typeof module !== 'undefined') {
        if (Object.getPrototypeOf(module) === Object.prototype) {
            ({module} = module)
        } else {
            console.warn('using deprecated parameters for `initSync()`; pass a single object instead')
        }
    }

    const imports = __wbg_get_imports();

    __wbg_init_memory(imports);

    if (!(module instanceof WebAssembly.Module)) {
        module = new WebAssembly.Module(module);
    }

    const instance = new WebAssembly.Instance(module, imports);

    return __wbg_finalize_init(instance, module);
}

async function __wbg_init(module_or_path) {
    if (wasm !== undefined) return wasm;


    if (typeof module_or_path !== 'undefined') {
        if (Object.getPrototypeOf(module_or_path) === Object.prototype) {
            ({module_or_path} = module_or_path)
        } else {
            console.warn('using deprecated parameters for the initialization function; pass a single object instead')
        }
    }

    if (typeof module_or_path === 'undefined') {
        module_or_path = new URL('color_module_bg.wasm', import.meta.url);
    }
    const imports = __wbg_get_imports();

    if (typeof module_or_path === 'string' || (typeof Request === 'function' && module_or_path instanceof Request) || (typeof URL === 'function' && module_or_path instanceof URL)) {
        module_or_path = fetch(module_or_path);
    }

    __wbg_init_memory(imports);

    const { instance, module } = await __wbg_load(await module_or_path, imports);

    return __wbg_finalize_init(instance, module);
}

export { initSync };
export default __wbg_init;
