export type Option = {
  label: string;
  value: string | number | null;
};

export type HarmonyColor = {
  color: string;
  ratio: number;
};

export type ColorDescription = {
  name: string;
  pinyin: string[];
  hue: number;
  lightness: number;
  category: string;
  tags: string[];
  rgb: [number, number, number];
  hsl: [number, number, number];
  lab: [number, number, number];
  oklch: [number, number, number];
};

export type SchemeType = 'color_q' | 'material_2' | 'material_3';
export type SchemeColor = string | null;
export type SchemeContent<Scheme> = {
  id: string;
  name: string;
  createdAt: string;
  description: string | null;
  type: SchemeType;
  lightScheme: Scheme;
  darkScheme: Scheme;
};
